Imports System.Windows.Forms
Imports System.Drawing
Imports System.ComponentModel

Public Class CtlAgenda

#Region "Variables"

    Private CtlCouleurFond As Color
    Private CtlCouleurStylo As Color

    Public Event ActionClik(ByVal sender As Object, ByVal e As EventArgs)

#End Region

#Region "Proprits"

    <Category("Agenda"), Description("Encodage de l'heure de dbut d'vnement")> _
    Public Property HeureDebut() As String
        Get
            Return LblHDeb.Text
        End Get
        Set(ByVal value As String)
            Try
                Dim Heure As DateTime
                Heure = CDate(value)
                Me.LblHDeb.Text = value

            Catch ex As Exception
                MessageBox.Show("votre encodage d'heure de dbut est incorrecte", "Erreur de proprits", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Property
            End Try

        End Set
    End Property
    <Category("Agenda"), Description("Encodage de l'heure de fin d'vnement")> _
    Public Property HeureFin() As String
        Get
            Return Me.LblHFin.Text
        End Get
        Set(ByVal value As String)
            Try
                Dim Heure As DateTime
                Heure = CDate(value)
                Me.LblHFin.Text = value

            Catch ex As Exception
                MessageBox.Show("votre encodage d'heure de dbut est incorrecte", "Erreur de proprits", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Property
            End Try
        End Set
    End Property
    <Category("Agenda"), Description("Encodage de l'vnement")> _
    Public Property TextEvent() As String
        Get
            Return TxtEvent.Text
        End Get
        Set(ByVal value As String)
            TxtEvent.Text = value
        End Set
    End Property
    <Category("Agenda"), Description("Affiche l'icne si un commentaire existe")> _
    Public Property Commentaire() As Boolean
        Get
            Return Me.PctComment.Visible
        End Get
        Set(ByVal value As Boolean)
            Me.PctComment.Visible = value
        End Set
    End Property
    <Category("Agenda"), Description("Affiche si une alarme est place sur l'vnment")> _
    Public Property Alarme() As Boolean
        Get
            Return Me.PctAlarme.Visible
        End Get
        Set(ByVal value As Boolean)
            Me.PctAlarme.Visible = value
        End Set
    End Property
    <Category("Agenda"), Description("Choix de l'image des commentaires")> _
    Public Property ImgComment() As Image
        Get
            Return Me.PctComment.Image
        End Get
        Set(ByVal value As Image)
            Me.PctComment.Image = value
        End Set
    End Property
    <Category("Agenda"), Description("Choix de l'image de l'alarme")> _
    Public Property ImgAlarme() As Image
        Get
            Return Me.PctAlarme.Image
        End Get
        Set(ByVal value As Image)
            Me.PctAlarme.Image = value
        End Set
    End Property
    <Category("Agenda"), Description("Choix de la couleur de fond")> _
    Public Property CouleurFond() As Color
        Get
            Return CtlCouleurFond
        End Get
        Set(ByVal value As Color)
            If value <> CtlCouleurStylo Then
                CtlCouleurFond = value
                Affichage()
            Else
                MessageBox.Show("Nous vous conseillons de choisir une couleur du fond diffrente de celle du style", "Avertissement", MessageBoxButtons.OK)
                Select Case CtlCouleurStylo
                    Case Color.Black
                        CtlCouleurFond = Color.White
                    Case Else
                        CtlCouleurFond = Color.Black
                End Select
                Affichage()
            End If
        End Set
    End Property
    <Category("Agenda"), Description("Choix de la couleur du stylo")> _
    Public Property CouleurStylo() As Color
        Get
            Return CtlCouleurStylo
        End Get
        Set(ByVal value As Color)
            If value <> CtlCouleurFond Then
                CtlCouleurStylo = value
                Affichage()
            Else
                MessageBox.Show("Nous vous conseillons de choisir une couleur de stylo diffrente de celle du fond", "Avertissement", MessageBoxButtons.OK)
                Select Case CtlCouleurFond
                    Case Color.Black
                        CtlCouleurStylo = Color.White
                    Case Else
                        CtlCouleurStylo = Color.Black
                End Select
                Affichage()
            End If
        End Set
    End Property

#End Region

#Region "Mthodes"

    Public Sub Affichage()
        Me.SpCEvent1.Panel1.BackColor = CtlCouleurFond
        Me.SpCEvent2.Panel2.BackColor = CtlCouleurFond
        Me.LblHDeb.ForeColor = CtlCouleurStylo
        Me.LblHFin.ForeColor = CtlCouleurStylo
    End Sub

    Private Sub OnActionClick(ByVal sender As Object, ByVal e As EventArgs)
        RaiseEvent ActionClik(sender, e)
    End Sub

#End Region

#Region "Evnements du contrle personnalis"
    Private Sub CtlAgenda_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '--- initialisation des couleurs dans les proprits 
        Me.CtlCouleurFond = Me.SpCEvent1.Panel1.BackColor
        Me.CtlCouleurStylo = Me.LblHDeb.ForeColor

        '--- initialisation des couleurs des controles de l'UC 
        Affichage()
    End Sub

    'Private Sub TxtEvent_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles TxtEvent.DoubleClick
    '    RaiseEvent ActionClik(sender, e)
    'End Sub
    'Private Sub LblHDeb_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles LblHDeb.Click, LblHFin.Click, PctAlarme.Click, PctComment.Click
    '    RaiseEvent ActionClik(sender, e)
    'End Sub

    'Private Sub SpCEvent2_Panel2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpCEvent2.Panel2.Click
    '    RaiseEvent ActionClik(sender, e)
    'End Sub
    'Private Sub SpCEvent1_Panel1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpCEvent1.Panel1.Click
    '    RaiseEvent ActionClik(sender, e)
    'End Sub


#End Region


End Class
